// 

/*

rev 06-04-2014
modif seq d'init

*/  


// 20-12-2013
//****  Blue Tooth click RN41  Mikroe  ******
#include <string.h>
#include <timers.h>
#include "BlueTooth/BT_RN41.h"
#include "Nokia3310/Nokia3310.h"


#ifndef OUT_RS232
#define OUT_RS232 Drapeaux.Lcd=0;
#define OUT_LCD Drapeaux.Lcd=1;
#endif
#define Led_Rouge LATAbits.LATA4


extern char CMD_mode;
extern int dummy;
extern char BT_state;
extern char response_rcvd;
extern char responseID;
extern char response;
extern volatile int DataReady1;
extern volatile unsigned int Cnt3;
extern int State;
extern volatile int i1,i2;
extern volatile unsigned int Elapsed;


extern void Tempo(unsigned long L);
extern int PutStr_RS(unsigned char *s);
extern int PutStrR_RS(rom unsigned char  *s);
extern void Put_RS(unsigned char untel);
extern void PutR_RS( rom unsigned char * untel);
extern unsigned char *PBT; // pointeur sur buffer
extern void Arme_Elapsed_Timer3(void);
void Test_BT_Answer(void);

void Test_BT_Answer()
{   OUT_LCD
    Nokia_Erase_Ligne(7);
    *(PBT+15)=0;
    Nokia_PutRamString(PBT); 
        
   if (Elapsed==0)   //<= a  4 secondes
   {
    State++;
    OUT_LCD
    gotoxy(48,3);  // 8em position => 8 x6
    sendchar(State+48); // ("Etape : 0 sur 8 ");
    Tempo(100000L); // pour ralentir la visu sur lCD
     }   
    else
    {
    State=0;
    Elapsed=0;
    Led_Rouge=0;  // allume led
    PIE2bits.TMR3IE=0; 
    }
    // rearme timeout pour chaque interrogation
    Cnt3=40;  //  20x100ms=2sec
    Arme_Elapsed_Timer3();
 }


int  BT_Configure()
{ 
 
  Led_Rouge=1;
  OUT_LCD
  gotoxy(0,3);//01234567890123456 
  Nokia_PutRomString("Etape : 0 sur 8 ");
  Tempo(100000L); 
  OUT_RS232
  dummy=PutStrR_RS("---");    // to be sure !
  Put_RS(13);
  Tempo(100000L); 
  dummy=PutStrR_RS("---");   
  Put_RS(13);
  State=0;
  Cnt3=80; // 80*100mS soit 8 sec
  Arme_Elapsed_Timer3();
 do 
  {  DataReady1=0; PIR1bits.RC1IF=0; 
      i1=0; 
      *(PBT)=0; // on nettoye avant..
   // Enter command mode, attend CMD
   // PAS de CR pour prise de contact !
   // suite test en prise directe Terminal <-> RN41 , il semblerait que 
   // la commande contigue $$$ ne passe pas , alors que 3x$ est toujours OK
   // attention Macro VBRAY pour envoi $$$ => mettre $$$$$$  car c'est un caractere special VBRAY
   // ou #036#036#036
    // attention ne pas activer l'ECHO sur le RN41
    Put_RS('$');Tempo(100); Put_RS('$');Tempo(100); Put_RS('$');    Tempo(1000);
    while ((DataReady1==0) && (Elapsed==0));
  } while ((memcmppgm2ram(PBT,"CMD",3)!=0)&& (Elapsed==0));
  Test_BT_Answer();
  if (State!=1) return(0); 
   
 do {DataReady1=0; PIR1bits.RC1IF=0; i1=0; *(PBT)=0; 
    dummy=PutStrR_RS("SN,MyBT-DB49\r"); //Name of the device, 20 characters maximum
     Tempo(1000);
    while ((DataReady1==0) && (Elapsed==0));
 } while ((memcmppgm2ram(PBT,"AOK",3)!=0) && (Elapsed==0));
 Test_BT_Answer();
 if (State!=2)return (0);
 
      
 do {
    DataReady1=0; PIR1bits.RC1IF=0; i1=0; *(PBT)=0;  
    dummy=PutStrR_RS("SU,19.2\r"); // Vitesse en bauds 
       Tempo(1000); 
     while ((DataReady1==0) && (Elapsed==0));
 }  while ((memcmppgm2ram(PBT,"AOK",3)!=0)&& (Elapsed==0));
 Test_BT_Answer();
 if (State!=3)return(0);
 
  do {DataReady1=0; PIR1bits.RC1IF=0; i1=0; *(PBT)=0; 
  dummy=PutStrR_RS("ST,255\r");   // Timer 255 => mode command permanent
     Tempo(1000); 
   while ((DataReady1==0) && (Elapsed==0));
 } while ((memcmppgm2ram(PBT,"AOK",3)!=0)&& (Elapsed==0));
 Test_BT_Answer();
 if (State!=4)return (0);
  
 do {
    DataReady1=0; PIR1bits.RC1IF=0; i1=0; *(PBT)=0; 
    dummy=PutStrR_RS("SI,0x800");
  // Set Inquiry interval is fixed at maximum=0x800,
    Put_RS(13);
     Tempo(1000); 
    while ((DataReady1==0) && (Elapsed==0));
  } while ((memcmppgm2ram(PBT,"AOK",3)!=0)&& (Elapsed==0));
 Test_BT_Answer();
 if (State!=5)return (0);

  do {DataReady1=0; PIR1bits.RC1IF=0; i1=0; *(PBT)=0;
    dummy=PutStrR_RS("SA,1");    // Authentication (1 to enable, 0 to disable)
    Put_RS(13);
     Tempo(1000); 
     while ((DataReady1==0) && (Elapsed==0));
 } while ((memcmppgm2ram(PBT,"AOK",3)!=0) && (Elapsed==0));
  Test_BT_Answer();
  if (State!=6)return (0);
    
  do {DataReady1=0; PIR1bits.RC1IF=0; i1=0; *(PBT)=0;
    dummy=PutStrR_RS("SP,1234");  // Security pin code (mikroe)
    Put_RS(13);
    Tempo(1000);
    while ((DataReady1==0) && (Elapsed==0));
  } while ((memcmppgm2ram(PBT,"AOK",3)!=0) && (Elapsed==0));
  Test_BT_Answer();
  if (State!=7)return (0);

  //   do {DataReady1=0; PIR1bits.RC1IF=0; i1=0; PBT[0]=0; 
  //  dummy=PutStrR_RS("---");   // fin mode config
 //   Put_RS(13);                          // CR
    //  Tempo(10000L); 
 //    while ((DataReady1==0) && (Elapsed==0));
 // }  while ((memcmppgm2ram(PBT,"END",3)!=0)&& (Elapsed==0));
//  Test_BT_Answer();
  State=8;
  return(State);        // si link OK on doit avoir State=8  
}



 
 void  Init_BT_RN41_direct()  // En aveugle,sans tester la reponse
{
     OUT_RS232
     dummy=PutStrR_RS("---"); 
      Put_RS(13);
    Tempo(15000);
    // Enter command mode 
    Put_RS('$');  Tempo(2000);
    Put_RS('$');  Tempo(2000);
    Put_RS('$');  Tempo(2000);
    Delay_mS(200);
    
    dummy=PutStrR_RS("SN,MyBT-DB49"); // Name of device
    Put_RS(13);
    Delay_mS(200);
   
    dummy=PutStrR_RS("SU,19.2"); // Vitesse en bauds 19200
    Put_RS(13);
    Delay_mS(200);
    
   // dummy=PutStrR_RS("SP,1234"); // <-- Standard PIN
    dummy=PutStrR_RS("SP,5678");  // special for HCO5 bleu
    Put_RS(13);
    Delay_mS(200);
    
    // dummy=PutStrR_RS("SA,1");    // Authentication (1 to enable, 0 to disable)
    dummy=PutStrR_RS("SA,0");    // open mode no encryption
    Put_RS(13);
    Delay_mS(200);

    dummy=PutStrR_RS("SO,18F_");   // Extended status string
    Put_RS(13);
     Delay_mS(200);
   
   
    dummy=PutStrR_RS("ST,250");   // 250 sec in CMD mode
    Put_RS(13);
     Delay_mS(200);
    
  // Set mode (0 = slave, 1 = master, 2 = trigger, 3 =auto, 4 = DTR, 5 = ANY 6=Payring)
    dummy=PutStrR_RS("SM,6");
    Put_RS(13);
    Delay_mS(200);
   
    dummy=PutStrR_RS("D");
    Put_RS(13);
    Delay_mS(200);
    
 // AT dialogue not yet closed !!
  
 // dummy=PutStrR_RS("---");        
 // Put_RS(13);
 // Tempo(15000);
}


