//12-04-2014
//error "verfifier void Nokia_PutRomString(const rom char *string"

//rev 24-02-2014
#include "p18f46k22_.h"
#include <string.h>
#include "Nokia3310/Nokia3310.h"
#include "Delays20M/Delays_20Mhz.h"



// ****  Nokia LCD 3310
extern void Put_RS(unsigned char untel);
extern void PutR_RS( rom unsigned char * untel);
extern unsigned char *PtableN;  // pointe sur table nokia 512bytes


void initlcd() 
{ 
 RES =1;
  Delay_mS(1);
 SCE =1;
  Delay_mS(1);
 RES =0;
 Delay_mS(250);
 RES=1;            // come out of lcd state
 sendcmd(0x21);    //Function SET: 00100_PD_V_H
  Delay_mS(10);
 sendcmd(0x88);    //was 0x90  VLCD=;3.06+162*0.06=4.02
  Delay_mS(10);
 sendcmd(0x05);    //; TC0=1 TC1=0
   Delay_mS(10);
 sendcmd(0x13);    //bias System 1:48 -> n=4
   Delay_mS(10);
 sendcmd(0x20);    //Function SET: 00100_PD_V_H
  Delay_mS(10);
 sendcmd(0x0C);
  Delay_mS(5);
 cleanram();
 Delay_mS(5);
 gotoxy(0,0);

} 

void sendcmd(char x) 
{ 
 D_C= 0;
   Delay_uS(2);
 SCE=0;
  Delay_uS(2);
 sendpack(x);
  Delay_uS(2);
 SCE=1; //deselect the display
} 

void senddata(char x) 
{ 
 D_C= 1;
 Delay_uS(2);
 SCE=0;
  Delay_uS(2);
 sendpack(x);
  Delay_uS(2);
 SCE=1; //deselect the display
} 

void cleanram() 
{int i; 
 gotoxy(0,0);
 for(i=0;i<=896;i++)
 {
 senddata(0x00);
   Delay_uS(2);// Delay1KTCYx(1);
 }
} 

void gotoxy( char x, char y) 
{
 sendcmd(0x40|(y&0x07));  // numero de ligne 0  7
   Delay_uS(10);     // numero de pixel 0  127   16 car de 6 pixels de large 
 sendcmd(0x80|(x & 0x7f));
    Delay_uS(10);
} 

void Nokia_Erase_Ligne(char Ligne)
{
    int i;
    gotoxy(0,Ligne);
    for (i=0;i<16;i++)  // 0  15=16cars
    {sendchar(0x20); 
     Delay_uS(5);
     }
    gotoxy(0,Ligne);   
}

void Nokia_Efface_Ligne(char Ligne)
{
    int i;
    gotoxy(0,Ligne);
    for (i=0;i<96;i++)  // 0  15=16cars
    {senddata(0x00); 
      Delay_uS(5); 
     }
    gotoxy(0,Ligne);   
}

void sendchar(char x) 
{ int a,b; 
 unsigned char c;
 if((x<0x20)||(x>0x7f)) return;
 a=(int)(x-32)*5;  //was (5*x)-0x00A0;
 for(b=5;b>0;b--)
  {  c=*(PtableN+a);
        Delay_uS(2);
     senddata(c);
    a++;
    
   }
 senddata(0x00);
}



void sendpack(char x) 
{ int i; 
 for(i=0;i<8;i++)
 {
  SCK=0;
  if ((x&0x80)==0x80) SDI=1; else SDI=0;
  Delay_uS(2);
  SCK=1;
  x=x<<1;
   }
} 

void Write_String(char * txt)
{
 short int i1,j1,k;
 j1=strlen(txt);
   i1=0;
   do
   {
   k=txt[i1];
   if (Drapeaux.Lcd==0)
      Put_RS(k);
   else
   sendchar(k);
    i1++;
   }while (i1<j1);
   if (Drapeaux.Lcd==0)
   {
    PutR_RS(10);
    PutR_RS(13);
   }
}

void Nokia_PutRomString(const rom char *string)
{ 

     while(*string)     
    {
        sendchar(* string);     
        string++;                         
    }
}

void Nokia_PutRamString( char *string)
{
    while(*string)                       
    {
        sendchar(*string);             
        string++;                     
    }
 }

void Nokia_Bargraph(char Ligne,int Value)
{int v,Cpt1;
    Nokia_Erase_Ligne(Ligne);
    if (Value==0) return;
    v= Value/11;        //  car 1024 points /96 pixels =11 points  par pixel
    for (Cpt1=0;Cpt1<v;Cpt1++)
    {
      gotoxy(Cpt1,Ligne);
      senddata(0b00111100);// Allume les pixels du centre
    }
 }



