
#include "RTC1302/RTC1302.h"
#include "Delays20M/Delays_20Mhz.h"
// modi 15-02-2014
// add lecture/ecriture 31 oectes en RAM DS1302
// modif  2-2-2014
//was CS IS
// #define DS1302_CS      LATCbits.LATC1  // pin 5 DS1302


// ****** RTC DS1302 **********
void write_byte(unsigned char C){
     unsigned char i;
     TrisIO=0;
     for(i=0;i<=7;++i)
     {
      IO_W=C & 0x01;
      C =C>>1;
      SCLK=1;
      Delay_uS(5);
      SCLK=0;
     }
 }
 
void  Write_Table_to_RAM_ds1302(char * b)
{int i; 
  unsigned char ad;
    i=0;
    while(*(b+i)>0)
    {
     DS1302_CS=1;
     ad=0xC0 + (i<<1);
     write_byte(ad);
     Delay_uS(10);
     write_byte(*(b+i));
      Delay_uS(10);
     DS1302_CS=0;
     i++;
     if (i>31) break;
   }  
}    
 
void Read_Table_from_RAM_ds1302(char * b)
{int i;
    unsigned char ad;
   for (i=0;i<32;i++)
   {DS1302_CS=1;
     ad=0xC1 + (i<<1);  
     *(b+i)=read_ds1302(ad);
      DS1302_CS=0;
   }  
}  
 
 
 void write_ds1302(unsigned char C, unsigned char D){
 
     DS1302_CS=1;
     write_byte(C);
     write_byte(D);
     DS1302_CS=0;
 }
 
 unsigned char read_ds1302(unsigned char C){
     unsigned char i,Data;
     DS1302_CS=1;
     write_byte(C);
     TrisIO=1;
     Nop();
     Data=0;
     for(i=0;i<=6;i++)
     {
       if(IO_R==1){Data+=0x80;}
       Data=Data >>1;
       SCLK=1;
       Nop();Nop();Nop();
       SCLK=0;
       Nop();Nop();Nop();
     }
     DS1302_CS=0;
     return(Data);
 }
 
 void ds1302_init(void)
     {
     unsigned char j;
     TrisIO=0;
     DS1302_CS=0;
     Nop();  Nop();
     Nop();  Nop();
     SCLK=0;
     write_ds1302(0x8E,0);
     write_ds1302(0x90,0xA4);
     j=read_ds1302(0x81);
     if((j & 0x80)!=0){
         write_ds1302(0x80,0);
     }    
 }
 
 unsigned char get_bcd(unsigned char C){
     unsigned char NibleH,NibleL;
     NibleH=C/10;
     NibleL=C-(NibleH*10);
     NibleH=NibleH << 4;
     return(NibleH|NibleL);
 }
 
 unsigned char rm_bcd(unsigned char C){
     unsigned char i;
     i=C;
     C=(i>>4)*10;
     C=C+(i<<4>>4);
     return(C);
 }
 
void set_datetime(unsigned char day, unsigned char mth,
     unsigned char year, unsigned char dow, 
      unsigned char hr, unsigned min){
     write_ds1302(0x80,get_bcd(0));
     write_ds1302(0x82,get_bcd(min));
     write_ds1302(0x84,get_bcd(hr));
     write_ds1302(0x86,get_bcd(day));
     write_ds1302(0x88,get_bcd(mth));
     write_ds1302(0x8A,get_bcd(dow));
     write_ds1302(0x8C,get_bcd(year));
 }
 
 unsigned char get_day() {
     return(rm_bcd(read_ds1302(0x87)));
 }
 unsigned char get_mth(){
    return(rm_bcd(read_ds1302(0x89)));
 }
 unsigned char get_year(){
    return(rm_bcd(read_ds1302(0x8D)));
 }
 unsigned char get_dow(){
    return(rm_bcd(read_ds1302(0x8B)));
 }
 unsigned char get_hr(){
    return(rm_bcd(read_ds1302(0x85)));
 }
 unsigned char get_min(){
    return(rm_bcd(read_ds1302(0x83)));
 }
 unsigned char get_sec(){
    return(rm_bcd(read_ds1302(0x81)));
 }


void Get_Date_Time()
{
 sec=get_sec();
 min=get_min();
 heure=get_hr();
 dow=get_dow();
 jour=get_day();
 mois=get_mth();
 An= get_year(); 
}    
