

#include"p18f46k22.h"

// PIC18F serie : il faut timer0 sur 16 bits 
// delais pour FOSC=206Mhz

void Delay_uS(unsigned int x);
void Delay_mS(unsigned int cnt);
void Delay_1S(void);

void Delay_uS(unsigned int x)
{unsigned int y;
 y=x;   
while(--y != 0);
 }

// at 20Mhz
void Delay_mS(unsigned int cnt)
{
  #ifdef DEBUG
  return;
  #else  
    
  INTCONbits.TMR0IE=0;     // no interrupt
  T0CON=0b00000001;  // Timer OFF, 16bits, internal, prescaler=1:4
  TMR0H=0xFB; //hi(64286);      // 1.0mS avec 1:4
  TMR0L=0x1E; //lo (64286);
  while(cnt>0)
  { 
  T0CONbits.TMR0ON=1;
  while(INTCONbits.TMR0IF == 0); // wait over
  INTCONbits.T0IF=0;
  cnt--;
  TMR0H=0xFB; //hi(64286);      // 1.0mS avec 1:4
  TMR0L=0x1E; //lo (64286);
  }
  T0CON=0;
  #endif

}
// at 20Mhz 
void Delay_1S(void)
{
  INTCONbits.TMR0IE=0;     // no interrupt
  T0CON=0b00000111;  // Timer OFF, 16bits, internal, prescaler=1:256
  TMR0H=0xB3; //hi(46004);      // 1.0 S avec 1:256
  TMR0L=0xB4; //lo (46004);
  T0CONbits.TMR0ON=1;
  while(INTCONbits.TMR0IF == 0); // wait over
  INTCONbits.T0IF=0;
  T0CON=0;
  TMR0H=0xB3; //hi(46004);      // 1.0 S avec 1:256
  TMR0L=0xB4; //lo (46004);
}